<?php
/**
 *
 * @file : jquery_twitter_search_admin.inc
 * 
 * This file contains administration functions 
 * and functionality implementation.
 * 
 */

function _jquery_twitter_search_admin_page() {
  //$build['add_block'] = "<div>" . l(t('Add block'), 'admin/config/jquery-twitter-search/add-block') . "</div>";
  
  $number_results = 10;

  $header = array();
  $header[] = array('data' => t('Block title'), 'field' => 'title');
  $header[] = array('data' => t('Operations'));
  
  $query = 'SELECT title, delta FROM {jquery_twitter_search}';
  $query .= tablesort_sql($header);

  $resource = pager_query($query);

  $row = array();
  while ($result = db_fetch_array($resource)) {
    
    $row['data']['title'] = $result['title'];
    $operations = l(t('edit'), "admin/settings/jquery-twitter-search/edit/" . $result['delta']);
    $operations .=  " | " . l(t('delete'), "admin/settings/jquery-twitter-search/del/" . $result['delta']);

    $row['data']['operations'] = $operations;
  }
  
  $output = "";
  $output .= theme('table', $header, $row);
  $output .= theme('pager', NULL, $number_results, 0);
  return $output;
}

/**
 * jquery twitter search block creation form.
 * 
 * @param $delta
 *   The id of the block.
 * 
 * @return the form array structre.
 */
function _jquery_twitter_search_admin_form($delta = NULL) {
  
  $form = array();
  
  if (arg(4)) {
    $block = _jquery_twitter_search_get_block_info(arg(4));
    $options = unserialize($block->options);
  }

  //print_r($options);die;
  
  $form['jqueryts_title'] = array(
    '#type' => 'textfield',
    '#title' => t('Block Title'),
    '#description' => t('Block title.'),
    '#required' => TRUE,
    '#default_value' => (!empty($block->title)) ? $block->title : '' ,
  );
  
  $form['jqueryts_term'] = array(
    '#type' => 'textfield',
    '#title' => t('Term'),
    '#required' => TRUE,
    '#description' => t('Term to search for.'),
    '#default_value' => (!empty($options['jqueryts_term'])) ? $options['jqueryts_term'] : '' ,
    '#maxlength' => 100,
  );

  $form['advanced_option'] = array(
    '#type' => 'fieldset',
    '#title' => t('Advanced option'),
    '#collapsible' => TRUE,
    '#collapsed' => FALSE,
  );

  $form['advanced_option']['jqueryts_term_title'] = array(
    '#type' => 'textfield',
    '#title' => t('Term title'),
    '#description' => t('title text to display when frame option is true (default = "term" text) if left empty the title will not appear.'),
    '#default_value' => (!empty($options['jqueryts_term_title'])) ? $options['jqueryts_term_title'] : '' ,
    '#maxlength' => 100,
  );

  $form['advanced_option']['jqueryts_term_title_link'] = array(
    '#type' => 'textfield',
    '#title' => t('Term title link'),
    '#description' => t('URL for title link.'),
    '#default_value' => (!empty($options['jqueryts_term_title_link'])) ? $options['jqueryts_term_title_link'] : 'null' ,
  );
  
  $form['advanced_option']['jqueryts_anchors'] = array(
    '#type' => 'checkbox',
    '#title' => t('Anchors'),
    '#description' => t('Enable embedded links in tweets.'),
    '#default_value' => (!empty($options['jqueryts_anchors'])) ? $options['jqueryts_anchors'] : TRUE ,
  );
  
  $form['advanced_option']['jqueryts_anim_out_speed'] = array(
    '#type' => 'textfield',
    '#title' => t('animation out speed'),
    '#description' => t('Speed of animation for top tweet when removed.'),
    '#default_value' => (!empty($options['jqueryts_anim_out_speed'])) ? $options['jqueryts_anim_out_speed'] : 2000 ,
    '#maxlength' => 4,
  );

  $form['advanced_option']['jqueryts_nim_in_speed'] = array(
    '#type' => 'textfield',
    '#title' => t('animation in speed'),
    '#description' => t('Speed of scroll animation for moving tweets up.'),
    '#default_value' => (!empty($options['jqueryts_nim_in_speed'])) ? $options['jqueryts_nim_in_speed'] : 1000 ,
    '#maxlength' => 4,
  );

  $form['advanced_option']['jqueryts_apply_styles'] = array(
    '#type' => 'checkbox',
    '#title' => t('Anchors'),
    '#description' => t('Apply default css styling or not.'),
    '#default_value' => (!empty($options['jqueryts_apply_styles'])) ? $options['jqueryts_apply_styles'] : FALSE ,
  );

  $form['advanced_option']['jqueryts_avatar'] = array(
    '#type' => 'checkbox',
    '#title' => t('Use avatar'),
    '#description' => t('Show or hide twitter profile images.'),
    '#default_value' => (!empty($options['jqueryts_avatar'])) ? $options['jqueryts_avatar'] : TRUE ,
  );

  $form['advanced_option']['jqueryts_bird'] = array(
    '#type' => 'checkbox',
    '#title' => t('Use Bird image'),
    '#description' => t('To show or hide twitter bird image.'),
    '#default_value' => (!empty($options['jqueryts_bird'])) ? $options['jqueryts_bird'] : TRUE ,
  );

  $form['advanced_option']['jqueryts_bird_link'] = array(
    '#type' => 'textfield',
    '#title' => t('Use Bird image link to'),
    '#description' => t('URL that twitter bird image should link to.'),
    '#default_value' => (!empty($options['jqueryts_bird_link'])) ? $options['jqueryts_bird_link'] : '' ,
  );

  $form['advanced_option']['jqueryts_bird_src'] = array(
    '#type' => 'textfield',
    '#title' => t('Use Bird image URL'),
    '#description' => t('twitter bird image.'),
    '#default_value' => (!empty($options['jqueryts_bird_src'])) ? $options['jqueryts_bird_src'] : 'http://cloud.github.com/downloads/malsup/twitter/tweet.gif' ,
  );

  $form['advanced_option']['jqueryts_colorexterior'] = array(
    '#type' => 'textfield',
    '#title' => t('Color exterior'),
    '#description' => t('CSS override of frame border-color and title background-color (#000000).'),
    '#default_value' => (!empty($options['jqueryts_colorexterior'])) ? $options['jqueryts_colorexterior'] : '#DDD' ,
    '#maxlength' => 20,
  );
  
  $form['advanced_option']['jqueryts_colorinterior'] = array(
    '#type' => 'textfield',
    '#title' => t('Color interior'),
    '#description' => t('CSS override of container background-color (#000000).'),
    '#default_value' => (!empty($options['jqueryts_colorinterior'])) ? $options['jqueryts_colorinterior'] : 'white' ,
    '#maxlength' => 20,
  );

  $form['advanced_option']['jqueryts_filter'] = array(
    '#type' => 'textfield',
    '#title' => t('Filter'),
    '#description' => t('Callback fn to filter tweets:  fn(tweetJson) { /* return false to skip tweet */ }.'),
    '#default_value' => (!empty($options['jqueryts_filter'])) ? $options['jqueryts_filter'] : 'null' ,
    '#maxlength' => 120,
  );

  $form['advanced_option']['jqueryts_pause'] = array(
    '#type' => 'checkbox',
    '#title' => t('Pause'),
    '#description' => t('Pause on hover.'),
    '#default_value' => (!empty($options['jqueryts_pause'])) ? $options['jqueryts_pause'] : TRUE ,
  );

  $form['advanced_option']['jqueryts_refresh_seconds'] = array(
    '#type' => 'textfield',
    '#title' => t('Refresh seconds'),
    '#description' => t('Number of seconds to wait before polling for newer tweets'),
    '#default_value' => (!empty($options['jqueryts_refresh_seconds'])) ? $options['jqueryts_refresh_seconds'] : 0 ,
    '#maxlength' => 2,
  );
  
  $form['advanced_option']['jqueryts_time'] = array(
    '#type' => 'checkbox',
    '#title' => t('Show the tweet time'),
    '#description' => t('Show or hide the time that the tweet was sent.'),
    '#default_value' => (!empty($options['jqueryts_time'])) ? $options['jqueryts_time'] : TRUE ,
  );
  
  $form['advanced_option']['jqueryts_timeout'] = array(
    '#type' => 'textfield',
    '#title' => t('Timeout'),
    '#description' => t('Delay betweet tweet scroll in milesecond'),
    '#default_value' => (!empty($options['jqueryts_timeout'])) ? $options['jqueryts_timeout'] : 4000 ,
    '#maxlength' => 4,
  );
  
  $form['advanced_option']['block_delta'] = array(
    '#type' => 'hidden',
    '#value' => (isset($block->delta)) ? $block->delta : '',
  );
  
  $form['submit'] = array(
    '#type' => 'submit',
    '#value' => t('Save')
  );
  
  return $form;
}

/**
 *  block creation form handler.
 */
function _jquery_twitter_search_admin_form_submit($form, &$form_state) {

  $settings = array();

  foreach ($form_state['values'] as $key => $value) {
    if (preg_match('/jqueryts_/', $key) && $key != 'jqueryts_title') {
      $settings[$key] = $value;
    }
  }

  $title = $form_state['values']['jqueryts_title'];
  $options = serialize($settings);
  
  if ($form_state['values']['block_delta']) {
    db_query('UPDATE {jquery_twitter_search} SET `title`="%s", `options` ="%s"', $title, $options);
  } 
  else {
    db_query('INSERT INTO {jquery_twitter_search} (`title`, `options`) VALUES ("%s", "%s")', $title, $options);
  }
  
  drupal_set_message(t('Block :block_title have been saved.', array(':block_title' => $form_state['values']['jqueryts_term'])));
  drupal_goto('admin/settings/jquery-twitter-search'); 
}

/**
 * delete jquery twitter search block from jquery_twitter_search table.
 * 
 * @param $delta
 *   the id of the block.
 */
function _jquery_twitter_search_admin_del_conf($delta = NULL) {
  if ($delta) { 
    db_query('DELETE FROM {jquery_twitter_search} WHERE `delta` = %d', $delta);
    $message = t('Block has been deleted.');
  } 
  else {
    $message = t('Wrong block.');
  }
  drupal_set_message(check_plain($message));
  drupal_goto('admin/settings/jquery-twitter-search');
}